stages:
  - test
  - build

variables:
  ASPNETCORE_ENVIRONMENT: CI
  SOLUTION: ProSkive.Services.Notifications
  SERVICE_NAME: notifications-service

unit tests:
  image: proskive/dotnet-nuget:2.1-sdk
  stage: test
  script:
    - dotnet test ${SOLUTION}.sln --filter TestCategory~Unit
  except:
    variables:
      - $CI_COMMIT_MESSAGE =~ /^[\[]?[Cc][Hh][Oo][Rr][Ee][\]]?:?.*/
      - $CI_COMMIT_MESSAGE =~ /^[\[]?[Dd][Oo][Cc][Ss][\]]?:?.*/


integration tests:
  image: proskive/dotnet-nuget:2.1-sdk
  stage: test
  services:
    - name: mailhog/mailhog:latest
      alias: proskive-ci-mailhog
    - name: mongo:3.6
      alias: proskive-ci-mongo
  variables:
    MONGO_INITDB_ROOT_USERNAME: ciUser
    MONGO_INITDB_ROOT_PASSWORD: ciUser
  script:
    - export SMTP_HOST=$MAILHOG__MAILHOG_PORT_1025_TCP_ADDR
    - export SMTP_PORT=$MAILHOG__MAILHOG_PORT_1025_TCP_PORT
    - dotnet test ${SOLUTION}.sln --filter TestCategory~Integration
  except:
    variables:
      - $CI_COMMIT_MESSAGE =~ /^[\[]?[Cc][Hh][Oo][Rr][Ee][\]]?:?.*/
      - $CI_COMMIT_MESSAGE =~ /^[\[]?[Dd][Oo][Cc][Ss][\]]?:?.*/

  
create dev image:
  image: docker:stable
  services:
    - docker:dind
  stage: build
  script:
    - CURRENT_DIR=`pwd`
    - DATE=`date +%y%m%d%H%M`
    - chmod +x ${CURRENT_DIR}/tools/showversion_linux
    - VERSION=`${CURRENT_DIR}/tools/showversion_linux dotnetcore ${CURRENT_DIR}/src/${SOLUTION}.csproj`
    - VERSION_LATEST=${VERSION}-edge
    - VERSION_TAGGED=${VERSION_LATEST}${DATE}
    - docker build -t ${CI_REGISTRY_IMAGE}:${VERSION_LATEST} ${CURRENT_DIR}
    - docker tag ${CI_REGISTRY_IMAGE}:${VERSION_LATEST} ${CI_REGISTRY_IMAGE}:${VERSION_TAGGED}
    - docker login -u gitlab-ci-token -p ${CI_JOB_TOKEN} ${CI_REGISTRY}
    - docker push ${CI_REGISTRY_IMAGE}:${VERSION_LATEST}
    - docker push ${CI_REGISTRY_IMAGE}:${VERSION_TAGGED}
  only:
    - develop
  except:
    variables:
      - $CI_COMMIT_MESSAGE =~ /^[\[]?[Cc][Hh][Oo][Rr][Ee][\]]?:?.*/
      - $CI_COMMIT_MESSAGE =~ /^[\[]?[Dd][Oo][Cc][Ss][\]]?:?.*/


create prerelease image:
  image: docker:stable
  services:
    - docker:dind
  stage: build
  script:
    - CURRENT_DIR=`pwd`
    - chmod +x ${CURRENT_DIR}/tools/showversion_linux
    - VERSION=`${CURRENT_DIR}/tools/showversion_linux dotnetcore ${CURRENT_DIR}/src/${SOLUTION}.csproj`
    - VERSION_TAGGED=${VERSION}-${CI_COMMIT_TAG##*-}
    - docker build -t proskive/${SERVICE_NAME}:${VERSION_TAGGED} ${CURRENT_DIR}
    - docker login -u ${DOCKERHUB_USER} -p ${DOCKERHUB_PW}
    - docker push proskive/${SERVICE_NAME}:${VERSION_TAGGED}
  only:
    - tags
  except:
    variables:
      - $CI_COMMIT_TAG =~ /^\[[Rr][Ee][Ll][Ee][Aa][Ss][Ee]\].*/
      - $CI_COMMIT_TAG =~ /^v(\d)+\.(\d)+\.(\d)+$/

create release image:
  image: docker:stable
  services:
    - docker:dind
  stage: build
  script:
    - CURRENT_DIR=`pwd`
    - chmod +x ${CURRENT_DIR}/tools/showversion_linux
    - VERSION=`${CURRENT_DIR}/tools/showversion_linux dotnetcore ${CURRENT_DIR}/src/${SOLUTION}.csproj`
    - VERSION_LATEST=latest
    - VERSION_TAGGED=${VERSION}
    - docker build -t proskive/${SERVICE_NAME}:${VERSION_LATEST} ${CURRENT_DIR}
    - docker tag proskive/${SERVICE_NAME}:${VERSION_LATEST} proskive/${SERVICE_NAME}:${VERSION_TAGGED}
    - docker login -u ${DOCKERHUB_USER} -p ${DOCKERHUB_PW}
    - docker push proskive/${SERVICE_NAME}:${VERSION_LATEST}
    - docker push proskive/${SERVICE_NAME}:${VERSION_TAGGED}
  only:
    - master
